// ------------------------------------------------------------
// [Vu[
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// ------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWV;
float4x4 mLastWV;
float4x4 mVP;
float3 vEyePos;
float3 vLightDir;
float4 vCol;

// ------------------------------------------------------------
// eNX`
// ------------------------------------------------------------
texture SrcMap;
sampler SrcSamp = sampler_state
{
    Texture = <SrcMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
	float3 Normal		: TEXCOORD0;
	float3 Eye			: TEXCOORD1;
};
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
	float4 Tex			: TEXCOORD0;
	float4 Velocity		: TEXCOORD1;
};
// -------------------------------------------------------------
OUTPUT VS(
      float4 Pos    : POSITION,          // f̒_
      float3 Normal : NORMAL             // f̖@
){
	OUTPUT Out = (OUTPUT)0;        // o̓f[^
	
	// Wϊ
	Out.Pos = mul(mul(Pos, mWV), mVP);		// Ԃ̍Wgp
	
	// F
	Out.Color = vCol * (0.7*max( dot(vLightDir, Normal), 0)// gUF
						+0.3);// F
	
	Out.Normal = Normal;		// F
	Out.Eye    = Pos - vEyePos;	// 
	
	return Out;
}
// -------------------------------------------------------------
float4 PS(OUTPUT In) : COLOR
{   
    float3 e = normalize(In.Eye);	// xNg
    float3 n = normalize(In.Normal);// @xNg
    float3 r = reflect(e,n);		// ˃xNg
    float3 RGB2Lum = {0.299, 0.587, 0.114};
	
	float power = pow(max(0,dot(r,vLightDir)), 32); // Phone
	float4 SpecCol = float4(10,13,15,0);			// ʔːF
	
	float4 Out = In.Color + SpecCol * power;
	
	// IuWFNg݂ꏊɂ̓At@Pɂ
	Out.a = 1;
	
    return Out;
}
// -------------------------------------------------------------
VS_OUTPUT VS_Blur(
      float4 Pos    : POSITION,          // f̒_
      float3 Normal : NORMAL             // f̖@
){
	VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	
	// Wϊ
	float4 x1 = mul(Pos, mWV);			// ̃r[W
	float4 x0 = mul(Pos, mLastWV);		// Pt[Õr[W
	float4 v = x1-x0;					// x
	float3 n = mul(Normal, mWV);		// r[Wnł̖@
	
	bool bFront = (0<=dot(n, v.xyz));	// xĂH
	float4 x = bFront ? x1 : x0;		// ɂāAʒu߂
	
	Out.Pos = mul(x, mVP);				// ˉeԂɕϊ
	
	// ˉeԂeNX`Ԃɕϊ
	Out.Tex.x =  Out.Pos.x + Out.Pos.w;
	Out.Tex.y = -Out.Pos.y + Out.Pos.w;
	Out.Tex.w = 2.0f*Out.Pos.w;
	
	// eNX`Wł̑x߂
	float4 s0 = mul(x0, mVP); s0 /= s0.w;
	float4 s1 = mul(x1, mVP); s1 /= s1.w;
	Out.Velocity = s1 - s0;
	Out.Velocity.x *= +0.5f;
	Out.Velocity.y *= -0.5f;
	
	return Out;
}
// ------------------------------------------------------------
// sNZVF[_vO
// ------------------------------------------------------------
float4 PS_Blur (VS_OUTPUT In) : COLOR
{   
    float4 Out = 0;
	const int   SAMPLES = 26;
	const float samples = SAMPLES;
	
	for(int i=0;i<SAMPLES;i++){
		float t = (float)(i+1)/samples;
		Out += tex2D( SrcSamp, In.Tex/In.Tex.w + t*In.Velocity );
	}
	Out /= samples;
	
    return Out;
}

// ------------------------------------------------------------
// eNjbN
// ------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // ʏ`
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
    pass P1
    {
        // [Vu[
        VertexShader = compile vs_1_1 VS_Blur();
        PixelShader  = compile ps_2_0 PS_Blur();
    }
}
